
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>swift详解之九---------------自动引用计数、循环引用 / 憋错料</title>

    <meta name="description" content="swift详解之九---------------自动引用计数、循环引用 自动引用计数.循环引用(这个必须理解,必须看) 注:本文详细介绍自动引用计数,以及各种循环引用问题.一网打尽! 1. 自动引用计数原理 Swift 使用ARC机制来跟踪和管理你的内存,一般情况下,Swift 的内存管理机制会一直起着作用,你无须自己来考虑内存的管理.ARC 会在类的实例不再被使用时,自动释放其占用的内存. 然而,在少数情况下,ARC 为了能帮助你管理内存,需要更多的关于你的代码之间关系的信息.本章描述了这些情况,并且为你示范怎样启用 ARC 来管理你的应用程序的内存. 为了确保在">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">swift详解之九---------------自动引用计数、循环引用</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>自动引用计数、循环引用（这个必须理解，必须看）</h2>
<p><code>注：本文详细介绍自动引用计数，以及各种循环引用问题。一网打尽！</code></p>
<hr />
<h3>1、 自动引用计数原理</h3>
<p>Swift 使用ARC机制来跟踪和管理你的内存，一般情况下，Swift 的内存管理机制会一直起着作用，你无须自己来考虑内存的管理。ARC 会在类的实例不再被使用时，自动释放其占用的内存。</p>
<p>然而，在少数情况下，ARC 为了能帮助你管理内存，需要更多的关于你的代码之间关系的信息。本章描述了这些情况，并且为你示范怎样启用 ARC 来管理你的应用程序的内存。</p>
<p>为了确保在使用中的实例不会被销毁 ， ARC会跟踪和计算每一个实例正在被多少属性、常量或者变量所使用，直到引用计数为 0 ，ARC就会销毁这个实例</p>
<p>所以，无论你将实例赋值给属性、变量或者常量的时候，他们都回创建此实例的强引用 ，会将实例保持住（引用计数+1） 只要强引用还在，实例是不允许销毁的 。&nbsp;<br />
下面来看一个例子就能轻松理解啦！</p>
<pre><code>class Student{
var name:String
init(name:String){
self.name = name;
print("\(name) 实例被创建了 ")
}
deinit{
print("\(self.name) 实例被销毁啦！！！")
}
}
var st1:Student?
var st2:Student?
var st3:Student?
//这里是一个强引用
st1 = Student(name:"张三") //张三 实例被创建了
st2 = st1
st3 = st1
//现在Student有三个强引用了
st1=nil;
st2=nil
//将这两个释放 ，这时候还有一个强引用
st3 = nil //张三 实例被销毁啦！！！
//这时候所有的强引用都释放 ， 则释放这个实例</code>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
<li>26</li>
<li>27</li>
<li>28</li>
</ul>
</pre>
<p>这里注释写的很清楚 ， 只有当所有的强引用释放掉 ，ARC才会释放这个实例</p>
<p>我们有时候会写出循环强引用的代码 。 如果两个实例互相持有对方的强引用 ，所以每个实例都会让对方一直存在着，一直不会被销毁 ，这就是所谓的循环强引用 。</p>
<h3>2 、类实例之间的循环强引用</h3>
<p>这时候你可以定义类之间的关系为弱引用或者无主引用，以替代强引用。从而解决循环强引用的问题 。</p>
<p>下面我们先来了解一下他是怎么产生的 ：</p>
<pre><code>
class Animal {
var name:String
var food:Food?
init(name:String){
self.name = name
}
deinit{
print("Animal 被销毁啦")
}
}
class Food {
var name:String
var animal:Animal?
init(name:String){
self.name = name
}
deinit{
print("Food 被销毁啦 ")
}
}</code>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
<li>26</li>
</ul>
</pre>
<p>这里在Animal类中引用了Food 在Food中引用了Animal ，都是强引用</p>
<pre><code>var dog:Animal? = Animal(name: "dog")
var dogFood:Food? = Food(name: "meat")
dog!.food = dogFood
dogFood!.animal=dog
dog = nil
dogFood = nil </code>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
</ul>
</pre>
<p>然而并不会调用析构函数 ，循环引用会一直阻止这两个实例被销毁 应用程序造成了内存泄露</p>
<ul>
<li>解决循环强引用问题</li>
</ul>
<p>Swift提供了两种办法来解决这个问题 弱引用 和 无主引用 对于生命周期中会变成nil的实例 使用弱引用 ，对于初始化赋值后。再也不会被赋值为nil的实例使用无主引用。</p>
<p>a 、弱引用</p>
<pre><code>class Animal1 {
var name:String
var food:Food1?
init(name:String){
self.name = name
}
deinit{
print("Animal1 被销毁啦")
}
}
class Food1 {
var name:String
weak var animal:Animal1?
init(name:String){
self.name = name
}
deinit{
print("Food1 被销毁啦 ")
}
}
var dog1:Animal1? = Animal1(name: "dog")
var dogFood1:Food1? = Food1(name: "meat")
dog1!.food = dogFood1
dogFood1!.animal=dog1
dogFood1 = nil
dog1 = nil
//Animal1 被销毁啦
//Food1 被销毁啦
//哈哈 两个都可以被销毁啦</code>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
<li>26</li>
<li>27</li>
<li>28</li>
<li>29</li>
<li>30</li>
<li>31</li>
<li>32</li>
<li>33</li>
<li>34</li>
<li>35</li>
<li>36</li>
<li>37</li>
<li>38</li>
</ul>
</pre>
<p>b 、无主引用&nbsp;<br />
无主引用也不会牢牢保持住引用的实例 ， 和弱引用不同 ，无主引用永远是有值得 。无主引用总是被定义位非可选类型 。你可以在声明的时候在前面加上关键字&nbsp;<code>unowend</code>&nbsp;来表示这是个无主引用&nbsp;&nbsp;<br />
ARC无法在实例销毁的时候将它设置位nil 因为非可选的变量永远不能被赋值为nil ，但是在实例销毁后也是无法用这个实例去访问无主引用的， 如果你强制访问 会报运行时错误</p>
<pre><code>class Customer {
var name:String
var card:Card?
init(name:String){
self.name = name
}
deinit{
print("Customer 被销毁")
}
}
class Card {
var name:String
unowned var customer:Customer    //一个卡肯定要对应一个顾客
init(name:String,cus:Customer){
self.name = name
self.customer = cus
}
deinit{
print("Card 被销毁")
}
}
var customer:Customer? = Customer(name: "张三")
var card:Card? = Card(name: "招商银行金卡", cus: customer!)
customer!.card = card
customer = nil
card = nil
//Customer 被销毁
//Card 被销毁
//card!.customer //fatal error: unexpectedly found nil while unwrapping an Optional value</code>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
<li>26</li>
<li>27</li>
<li>28</li>
<li>29</li>
<li>30</li>
<li>31</li>
<li>32</li>
<li>33</li>
</ul>
</pre>
<p>这个也被顺利的销毁 ，当销毁后再取访问的时候就不能访问了</p>
<p>前面两种解决循环引用的场景 ，第一种是两个都允许为nil , 第二个是有一个不允许为nil，但是如果两个属性都不允许位nil ，初始化完成后永远不能为nil ，这时候就需要一个类使用无主 ， 另一个使用隐式解析可选属性&nbsp;&nbsp;<br />
c、隐式解析可选属性</p>
<pre><code>class Country{
var name:String
var city:City!
init(name:String,cityName:String){
self.name = name
self.city = City(name: cityName, country: self)
}
deinit{
print("Country 被销毁啦 ")
}
}
class City{
var name:String
unowned var country:Country
init(name:String,country:Country){
self.name = name
self.country=country
}
deinit{
print("City 被销毁啦")
}
}</code>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
<li>26</li>
<li>27</li>
</ul>
</pre>
<pre><code>
var country:Country? = Country(name: "China", cityName: "ShangHai")
//这一条语句创建了两个实例
var city = country!.city
print(city.country.name) //China
city = nil
country!.city = nil //City 被销毁啦
country = nil //Country 被销毁啦</code>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
</ul>
</pre>
<p>这里注释都写的很清楚，代码很简单 ，就不再赘述</p>
<h3>3、闭包引起的循环强引用</h3>
<p>循环强引用还会发生在你将一个闭包赋值给一个类的属性 ， 闭包中又使用了这个类的实例 ，其实 这跟之前的是一样的 ，因为闭包也是引用类型的 ， 你把一个引用类型赋值给一个属性 ，然后在这个引用类型中使用这个实例 ，两个强引用一直有效.&nbsp;<br />
使用闭包捕获列表可以解决这个问题</p>
<p>下面看看 这个问题是怎么产生的 .</p>
<pre><code>
class Book{
var name:String
//这里定义为lazy才可以使用self 。在构造器第一阶段还不能使用self
lazy var oldName:Void -&gt; String = {
return "old\(self.name)"
}
init(name:String){
self.name = name
}
deinit{
print("Book 被销毁了")
}
}
var book:Book? = Book(name: "Swift书")
print(book!.oldName()) //oldSwift书
//oldName是一个闭包
book = nil</code>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
</ul>
</pre>
<p>这时候并没有打印出析构方法的句子。明显产生了循环引用</p>
<p>解决办法 ：&nbsp;<br />
定义捕获列表：捕获列表中的每一项都由一对元素组成 ，一个是weak 或者 unowned ，另一个是类的实例或者初始化变量</p>
<pre><code>
class Book1{
var name:String
//这里定义为lazy才可以使用self 。在构造器第一阶段还不能使用self
lazy var oldName:Void -&gt; String = {
[unowned self] in
return "old\(self.name)"
}
init(name:String){
self.name = name
}
deinit{
print("Book 被销毁了")
}
}
var book1:Book1? = Book1(name: "Swift书")
print(book1!.oldName()) //oldSwift书
//oldName是一个闭包
book1 = nil  //Book 被销毁了</code>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
</ul>
</pre>
<p>这时会就被顺利销毁了</p>
<p>看下语法 ：</p>
<pre><code>@lazy var someClosure: (Int, String) -&gt; String = {
[unowned self] (index: Int, stringToProcess: String) -&gt; String in
// closure body goes here
}
@lazy var someClosure: () -&gt; String = {
[unowned self] in
// closure body goes here
}</code>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
</ul>
</pre>
<p>按照上述两种语法就可以了。</p>
<p>当闭包和捕获的实例总是互相引用时并且总是同时销毁时，将闭包内的捕获定义为无主引用。</p>
<p>相反的，当捕获引用有时可能会是nil时，将闭包内的捕获定义为弱引用。弱引用总是可选类型，并且当引用的实例被销毁后，弱引用的值会自动置为nil。这使我们可以在闭包内检查它们是否存在</p>
<p>@import url(http://i.cnblogs.com/CuteSoft_Client/CuteEditor/Load.ashx?type=style&amp;file=SyntaxHighlighter.css);@import url(/css/cuteeditor.css);</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-27 23:08:32 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>swift详解之九---------------自动引用计数、循环引用的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RwYNj3.html" rel="bookmark">Git详解之九 Git内部原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				来自:http://www.open-open.com/lib/view/open1328070620202.html Git 内部原理 不管你是从前面的章节直接跳到了本章,还是读完了其余各章一直到这,你都将在本章见识 Git 的内部工作原理和实现方式.我个人发现学习这些内容对于理解 Git 的用处和强大是非常重要的,不过也有人认为这些内容对于初学者来说可能难以理解且过于复杂.正因如此我把这部分内容放在最后一章,你在学习过程中可以先阅 读这部分,也可以晚点阅读这部分,这完全取决于你自己. 既然已			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jAZRDM.html" rel="bookmark">Git详解之九：Git内部原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Git 内部原理 不管你是从前面的章节直接跳到了本章,还是读完了其余各章一直到这,你都将在本章见识 Git 的内部工作原理和实现方式.我个人发现学习这些内容对于理解 Git 的用处和强大是非常重要的,不过也有人认为这些内容对于初学者来说可能难以理解且过于复杂.正因如此我把这部分内容放在最后一章,你在学习过程中可以先阅 读这部分,也可以晚点阅读这部分,这完全取决于你自己.(伯乐在线注:如果你对Git还不了解,建议从本Git系列第一篇文章开始阅读) 既然已经读到这了,就让我们开始吧.首先要弄明白一点			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M68pQv3.html" rel="bookmark">swift详解之十九--------------UITableView的基本操作&lpar;下拉刷新，新增删除，分组，检索等&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				UITableView的基本操作(下拉刷新,新增删除,分组,检索等) 注:本小结总结UITableview的一些基本用法 UITbleView继承自UIScrollView,只能用来显示一列数据(目前就只认识到这里),纵向滑动. 一般有两种方式来实现,直接用UITableViewController , 占满整个屏幕 .不用手动实现UITableViewDataSource 和UITableViewDelegate .另一种方式在UIViewController 中.我们看看这种方式 let t			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j56joM.html" rel="bookmark">Swift详解之四-------妈妈再也不用担心我的闭包了</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				妈妈再也不用担心我的闭包了 注:本文为作者自己总结,过于基础的就不再赘述 ,都是亲自测试的结果.如有错误或者遗漏的地方,欢迎指正,一起学习. swift中闭包是一个很强大的东西,闭包是自包含的函数代码块,可以在代码中被传递和使用.跟C 和 Objective-C 中的代码块(blocks)很相似 .这个大家必须掌握!必须掌握!必须掌握!重要的事情要说三遍 闭包可以捕获和存储其所在上下文中任意常量和变量的引用. 这就是所谓的闭合并包裹着这些常量和变量,俗称闭包.下面我们就来攻克它! 1.闭包函数			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KqVem4.html" rel="bookmark">swift详解之十-------------异常处理、类型转换 &lpar; Any and AnyObject &rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				异常处理.类型转换 ( Any and AnyObject ) 1.错误处理 (异常处理) swift 提供第一类错误支持 ,包括在运行时抛出 ,捕获 , 传送和控制可回收错误.在swift中 ,错误用复合 ErrorType 协议的值表示 . Swift枚举把一系列相关的错误组合在一起.同时可以把一些相关的值和错误关联在一起 . 因此 编译器会为实现ErrorType协议的Swift枚举类型自动实现相应的合成 这里看个很简单的小例子. enum WrongName:ErrorType{ cas			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Zb1dZ3.html" rel="bookmark">Swift 详解之一  --------  变量声明</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				变量声明 1.普通变量 swift 像javascript一样是可以智能推断类型的,他会根据我们变量的值来推断变量的类型 var age = 10 // Int var name =&quot;lily&quot; //编译器会自动推断出String static let name = &quot;MyClass&quot; //静态常量 通过类名直接访问 eg: ClassName.name 2.存储型变量或者存储型属性 语法:var variable name: type = expression 例			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35rVvV4.html" rel="bookmark">swift详解之十四 -----------NSThread 异步下载图片</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				NSThread 异步下载图片 在IOS中处理多线程有三个方案 , NSThread .NSOperation .GCD .当然GCD应该是最方便的 ,我们一个一个学 .先理解底层的,最后再使用最方便的 . NSThread: 优点:NSThread 比其他两个轻量级 缺点:需要自己管理线程的生命周期,线程同步.线程同步对数据的加锁会有一定的系统开销 我们先研究下用NSThread 异步加载网络图片 : NSThread有两种创建方式 ,一种是通过实例方法.一种是通过类方法. let threa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wNyZQ0.html" rel="bookmark">swift详解之十二-----------------泛型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				泛型 注:本文详细讲解泛型,对写一些公共方法,共用的东西的时候很有帮助.想成为一个优秀的程序员吗?这个必须掌握 泛型代码可以让你写出根据自我需求定义.适用于任何类型的,灵活可重用的函数和类型. 下面直接看一个简单的示例 , 泛型其实就是在写的时候不指定是哪种类型 , 只有再用得时候才指定类型 ,这些类型可以给一些限定.例如 Array Dictionary 等 写一个简单的交换数据的方法,不限定类型 func swapTwoValue&lt;T&gt;(inout a:T,inout _ b:T){ le			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OQzD7M.html" rel="bookmark">Swift详解之三----------函数&lpar;你想知道的都在这里&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				函数(你想知道的都在这里) 注:本文为作者自己总结,过于基础的就不再赘述 ,都是亲自测试的结果.如有错误或者遗漏的地方,欢迎指正,一起学习. 1. 函数的简单定义和调用 简单的无参函数就不再赘述 , name为形参 ,也是内部在数名 . func sayHello(name:String) -&gt;String { return name+&quot; say: hello&quot; } 调用的时候也很简单 sayHello(&quot;zhangsan&quot;) 是不是很简单呀! 2.外部参数名			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j4NGVGM.html" rel="bookmark" class="title">【LCA&sol;tarjan】POJ1470-Closest Common Ancestors</a>
					<div>
						[题意] 给出一棵树和多组查询,求以每个节点为LCA的查询数有多少? [错误点] ①读入的时候,注意它的空格是随意的呀!一开始不知道怎么弄,后来看了DISCUSS区大神的话: 询问部分输入: scan ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38NWEZM.html" rel="bookmark" class="title">数据完整性&lpar;Data Integrity&rpar;笔记</a>
					<div>
						因数据库存储数据要持之以恒,数据库中的表需要一些方法验证各种数据类型.不仅仅局限于数据类型,还有唯一值,值的范围,或者某列的值和另外一个表中的列匹配. 当你在定义表的时候其用这些数据验证方法.这叫做声 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6Ngb5M.html" rel="bookmark" class="title">MVC WebApi 用户验证 &lpar;2&rpar;</a>
					<div>
						构建ASP.NET MVC5+EF6+EasyUI 1.4.3+Unity4.x注入的后台管理系统(66)-MVC WebApi 用户验证 (2) 前言: 构建ASP.NET MVC5+EF6+Eas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41gqoP0.html" rel="bookmark" class="title">PHP基础知识点汇总（三）</a>
					<div>
						三.PHP的函数应用 函数:是指一个被命名的,独立的代码段,它执行特定的任务,并可能给它的程序返回一个值! 函数的声明: function 函数名([参数1,参数2...参数n]){ 函数体; ret ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4182gJ3.html" rel="bookmark" class="title">&lbrack;HackerRank&rsqb; The Longest Common Subsequence</a>
					<div>
						This is the classic LCS problem. Since it requires you to print one longest common subsequence, just ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38Lj2W3.html" rel="bookmark" class="title">C&plus;&plus; Primer Plus（五）&mdash;&mdash;循环和关系表达式</a>
					<div>
						优先级表表明,赋值运算符是从右向左结合的 定义一个const值来表示数组中元素的个数是一个好办法 对同一条语句的同一个值递增或递减多次,C++没有定义这种行为,也就是说这条语句在不同的系统上将生成不同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/498dqb3.html" rel="bookmark" class="title">&lbrack;C&sol;C&plus;&plus;&rsqb;&lowbar;&lbrack;初级&rsqb;&lowbar;&lbrack;判断大小端序Little Endian Order&rsqb;</a>
					<div>
						场景: 1. 在读取硬盘数据和媒体数据时,需要根据读取的数据进行大小端序的转换,以正确识别数据.其中一个处理就是首先要判断cpu支持的大小端序情况才能转换. 2. Little Endian Orde ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qa9l53.html" rel="bookmark" class="title">欧几里德算法求最大公约数</a>
					<div>
						求最大公约数有暴力法和辗转相除法 时间复杂度 暴力:O(N) 辗转相除法:O(2logN) 辗转相除法原理: 设c为A B 的最大公约数 则存在K1 K2 使 A=K1*c B=K2*c; r为A模B ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NqlQZ3.html" rel="bookmark" class="title">1022</a>
					<div>
						1 #include &lt;iomanip&gt; 2 #include &lt;iostream&gt; 3 #include &lt;cmath&gt; 4 using namespace st ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wjAKZ0.html" rel="bookmark" class="title">电信错误代码表示宽带问题</a>
					<div>
						651 win7及win7以上系统网络不通 678 xp系统网络不通 683 运营商问题 691 宽带拨号账号可能存在密码错误问题					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo5leQ3.html" rel="bookmark" class="title">智能指针的使用与陷阱</a>
					<div>
						在包含指针的类中需要注意复制控制,复制指针时只复制指针中的地址,不会复制指针指向的对象. 大多数c++类采用三种方法管理指针成员: 1)指针成员采用常规指针型行为. 2)采用智能指针 3)采取值型行为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoLXrD0.html" rel="bookmark" class="title">VisualSVN Server 安装出错</a>
					<div>
						安装VisualSVN Server 时提示:Custom actionGenerateSSLKey failed: Command terminated with non-zero exit cod ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RmdrPM.html" rel="bookmark" class="title">在linux环境下搭建java web测试环境（非常详细！！）</a>
					<div>
						一.项目必备软件及基本思路 项目必备:虚拟机:VMware Workstation (已安装linux的 CentOS6.5版本) 项目:java web项目 (必须在本地部署编译后选择项目的webR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pN8yK0.html" rel="bookmark" class="title">基于jquery的-验证码读秒</a>
					<div>
						在制作短信验证的时候,需要做一个获取短信按钮,点击后显示倒计时, html代码如下: 1 &lt;input class=&quot;gain&quot; type=&quot;button&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k67dXM.html" rel="bookmark" class="title">Welcome to Jekyll &excl;&excl;&excl;</a>
					<div>
						You'll find this post in your _posts directory. Go ahead and edit it and re-build the site to see yo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47odW64.html" rel="bookmark" class="title">组策略-禁止所有可移动存储使用</a>
					<div>
						实例环境: l 企业中有AD域(活动目录)环境. l 行政部&quot;用户A&quot;登录至公司内的一台计算机. l 通过组策略对&quot;用户A&quot;的USB使用进行限制. 1.在组策略 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0agZ6n4.html" rel="bookmark" class="title">jboss使用说明书bycai</a>
					<div>
						1,安装jdk,设置环境变量java_home=C:\Program Files (x86)\Java\jdk1.8.0_45 2,运行java,javac应该可以正常找到,如找不到,应进一步安装jr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX1e9X0.html" rel="bookmark" class="title">windows8开发-关于wp7应用迁移到win8 metro风格</a>
					<div>
						虽然微软说,wp7应用移植到win8上面是比较简单,只需要修改部分API和设计原则上的细节,同时它也提供了一份比较简洁的参考文档: 而实际上这种移植的工作量还是不小的,尤其当应用引用了较多底层的API ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e87BEM.html" rel="bookmark" class="title">常见网络协议简介</a>
					<div>
						IPv4 网际协议版本4(Internet Protocol version 4).自20世纪80年代早期以来一直是网际协议簇的主力协议.它使用32位地址.IPv4给TCP.UDP.SCTP.ICMP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dYJrz3.html" rel="bookmark" class="title">微框架spark--api开发利器</a>
					<div>
						spark简介 Spark(注意不要同Apache Spark混淆)的设计初衷是,可以简单容易地创建REST API或Web应用程序.它是一个灵活.简洁的框架,大小只有1MB.Spark允许用户自己选 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
